SystemOrganization addCategory: #GOODSCollections!

Collection subclass: #KKIdentityBTree
	instanceVariableNames: 'database tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODSCollections'!

!KKIdentityBTree class methodsFor: 'as yet unclassified' stamp: 'avi 10/27/2004 16:04'!
database: aDatabase
	^ self basicNew initializeWithDatabase: aDatabase! !

!KKIdentityBTree methodsFor: 'accessing' stamp: 'avi 10/27/2004 16:05'!
at: anObject
	^ tree at: (database keyForObject: anObject)! !

!KKIdentityBTree methodsFor: 'accessing' stamp: 'avi 10/27/2004 16:05'!
at: anObject ifAbsent: errorBlock
	^ tree at: (database keyForObject: anObject) ifAbsent: errorBlock! !

!KKIdentityBTree methodsFor: 'accessing' stamp: 'avi 10/27/2004 16:07'!
at: anObject ifAbsentPut: errorBlock
	^ tree at: (database keyForObject: anObject) ifAbsentPut: errorBlock! !

!KKIdentityBTree methodsFor: 'accessing' stamp: 'avi 10/27/2004 16:06'!
at: anObject put: valueObject
	^ tree at: (database keyForObject: anObject) put: valueObject! !

!KKIdentityBTree methodsFor: 'enumerating' stamp: 'avi 10/27/2004 16:08'!
do: aBlock
	tree do: aBlock! !

!KKIdentityBTree methodsFor: 'initialization' stamp: 'avi 10/27/2004 16:05'!
initializeWithDatabase: aDatabase
	database := aDatabase.
	tree := BTree order: 64.! !

!KKIdentityBTree methodsFor: 'enumerating' stamp: 'avi 10/27/2004 16:07'!
keysAndValuesDo: aBlock
	tree keysAndValuesDo:
		[:k :v |
		aBlock value: (database at: k) value: v]! !

!KKIdentityBTree methodsFor: 'enumerating' stamp: 'avi 10/27/2004 16:12'!
keysDo: aBlock
	self keysAndValuesDo: [:k :v | aBlock value: k]! !

!KKIdentityBTree methodsFor: 'accessing' stamp: 'avi 10/27/2004 16:08'!
values
	^ tree values! !

Set subclass: #KKIdentitySet
	instanceVariableNames: 'database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODSCollections'!

!KKIdentitySet class methodsFor: 'as yet unclassified' stamp: 'avi 7/6/2004 12:24'!
database: aKKDatabase
	^ self new initializeWithDatabase: aKKDatabase! !

!KKIdentitySet methodsFor: 'initialization' stamp: 'avi 7/6/2004 12:24'!
initializeWithDatabase: aKKDatabase
	database := aKKDatabase! !

!KKIdentitySet methodsFor: 'private' stamp: 'avi 7/10/2004 02:01'!
species
	^ IdentitySet! !
